Summary: highly available clustering web server 
Name: eddie
#
########################################
# Uncomment "%define" and "Requires"
# for your intended RedHat version
#
##### RedHat 5.2 #####
#%define rhrel 5.2
#Requires: redhat-release < 6.0
#
##### RedHat 6.0 #####
%define rhrel 6.0
Requires: redhat-release >= 6.0
########################################
#
%define rel 0
Version: 1.3.0
Release: %{rel}.%{rhrel}
Copyright: Ericsson Public License
Group: Networking/Utilities
Source0: eddie-%{version}.tar.gz
Provides: eddie
BuildRoot: /var/tmp/eddie-root
URL: http://www.eddieware.org/
Packager: geoff@eddieware.org


%description
Eddie is a highly available clustering web server.
It allows arbitrary scaling of a single virtual web site.
Load balancing is supported at two levels. Load balancing
is done at the cluster level with the Load Balancing DNS,
and within the cluster by the Intelligent HTTP gateway.
IP migration is used to implement a failover mechanism. 
Admission control allows web sites to control the load on 
their machines and provide a guaranteed level of service
from the backends.

NOTE: this RPM is intended for RedHat %{rhrel} systems.


%prep
%setup


%build
OPTIM="$RPM_OPT_FLAGS" ./configure \
	--prefix=/usr/local \
	--sysconfdir=/etc/eddie
make


%install
rm -rf $RPM_BUILD_ROOT
make install root="$RPM_BUILD_ROOT"

cp	$RPM_BUILD_ROOT/etc/eddie/eddie.conf \
	$RPM_BUILD_ROOT/etc/eddie/eddie.conf.default
cp	$RPM_BUILD_ROOT/etc/eddie/eddie.gate \
	$RPM_BUILD_ROOT/etc/eddie/eddie.gate.default
cp	$RPM_BUILD_ROOT/etc/eddie/eddie.mig \
	$RPM_BUILD_ROOT/etc/eddie/eddie.mig.default


%clean
rm -rf "$RPM_BUILD_ROOT"


%files
%defattr(644 root root 755)
%attr(775,root,root)  %dir /etc/eddie
%attr(750,root,daemon)  %config(noreplace) /etc/eddie/eddie.conf
%attr( - ,root,root)  %config(noreplace) /etc/eddie/eddie.gate
%attr( - ,root,root)  %config(noreplace) /etc/eddie/eddie.mig
%attr( - ,root,root)  /etc/eddie/eddie.conf.default
%attr( - ,root,root)  /etc/eddie/eddie.gate.default
%attr( - ,root,root)  /etc/eddie/eddie.mig.default

%attr(750,root,daemon)  /usr/local/sbin/eddie
%attr( - ,root,root)  /usr/local/sbin/lbdns
%attr( - ,root,root)  /usr/local/lib/eddie


%changelog
* Tue Sep 23 1999 Magnus Stenman <stone@hkust.se>
- revamped spec file


